<template>
  <div class="get-user-media">
    <div class="info">
      <BaseImg
        src="/enable-user-media-helper.svg"
        :cdn="false"
        class="enable-user-media-image"
      />
      <JText
        weight="bold"
        type="title-3"
        color="secondary-title"
      >
        Вам действительно не нужны звук и видео?
        Если передумаете, щелкните значок камеры рядом с адресной строкой, затем
        <u>Всегда разрешать</u>
      </JText>

      <JButton
        size="xs"
        class="continue-without-media-btn"
        @click="onClick(chat.getId())"
      >
        Продолжить без звука и видео
      </JButton>

      <JText
        weight="bold"
        type="text-5"
        color="secondary-title"
      >
        Проверьте, что микрофон и камера не используются другими приложениями.
      </JText>
    </div>
  </div>
</template>

<script setup lang="ts">
import { inject, PropType } from 'vue';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import { JText, JButton } from '@new-jira-clone/ui/src/components';
import { IChat } from '@/shared';
import useSendOffer from './useSendOffer';
import ConnectionAnswer from './ConnectionAnswer.vue';
import useSendAnswer from './useSendAnswer';
import { useMediaStreamStore } from './useMediaStreamStore';

const props = defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
});

const $dialog = inject('$dialog') as DialogPlugin;

const makeCallWithoutMedia = async (chat: IChat) => {
  const { sendOffer } = useSendOffer();

  $dialog.closeModal();

  $dialog.show(ConnectionAnswer, {
    contentProps: {
      connectionTarget: chat,
    },
  });
};

// eslint-disable-next-line no-undef
const acceptCallWithoutMedia = async (chat: IChat, offer: RTCSessionDescriptionInit) => {
  const { sendAnswer } = useSendAnswer();

  $dialog.closeModal();

  sendAnswer(chat, offer, {
    audio: false,
    video: false,
  });

  $dialog.show(ConnectionAnswer, {
    contentProps: {
      connectionTarget: chat,
    },
  });
};

const onClick = (chatId: string) => {
  const { getRtcDescription } = useMediaStreamStore();

  const rtcDescription = getRtcDescription(chatId);

  if (rtcDescription.value) {
    acceptCallWithoutMedia(props.chat, rtcDescription.value);
  } else {
    makeCallWithoutMedia(props.chat);
  }
};
</script>

<style scoped lang="scss">
.get-user-media {
  max-width: 560px;
}

.info {
  text-align: center;
}

.continue-without-media-btn {
  margin: 0 auto;
  margin-top: 30px;
  margin-bottom: 20px;
}

.enable-user-media-image {
  margin-bottom: 20px;
}
</style>
